---
title: KeyframeEffect.getKeyframes()
slug: Web/API/KeyframeEffect/getKeyframes
tags:
  - API
  - Animation
  - Experimental
  - KeyframeEffect
  - Method
  - Reference
  - getKeyframes
  - waapi
  - web animations api
---
<p>{{ SeeCompatTable() }}{{ APIRef("Web Animations API") }}</p>

<p>The <code><strong>getKeyframes()</strong></code> method of a {{domxref("KeyframeEffect")}} returns an Array of the computed keyframes that make up this animation along with their computed offsets.</p>

<h2 id="Syntax">Syntax</h2>

<div class="syntaxbox">
<pre class="brush: js">var keyframes = keyframeEffect.<em><code>getKeyframes()</code></em>;
</pre>
</div>

<h3 id="Parameters">Parameters</h3>

<p>None.</p>

<h3 id="Return_value">Return value</h3>

<p>Returns a sequence of objects with the following format:</p>

<dl>
 <dt>property value pairs</dt>
 <dd>
 <p>As many property value pairs as are contained in each keyframe of the animation.</p>
 </dd>
 <dt>offset</dt>
 <dd>
 <p>The offset of the keyframe specified as a number between <code>0.0</code> and <code>1.0</code> inclusive or <code>null</code>. This is equivalent to specifying start and end states in percentages in CSS stylesheets using <code>@keyframes</code>. This will be <code>null</code> if the keyframe is automatically spaced using <code>{{domxref("KeyframeEffect.spacing")}}</code>.</p>
 </dd>
 <dt>computedOffset</dt>
 <dd>
 <p>The computed offset for this keyframe, calculated when the list of computed keyframes was produced according to <code>{{domxref("KeyframeEffect.spacing")}}</code>. Unlike <strong><code>offset</code>,</strong> above, the <strong><code>computedOffset</code></strong> is never <code>null</code>.</p>
 </dd>
 <dt>easing</dt>
 <dd>
 <p>The <a href="/en-US/docs/Web/CSS/timing-function">timing function</a> used from this keyframe until the next keyframe in the series.</p>
 </dd>
 <dt>composite</dt>
 <dd>
 <p>The {{domxref("KeyframeEffect.composite")}} operation used to combine the values specified in this keyframe with the underlying value. This will be absent if the composite operation specified on the effect is being used.</p>
 </dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>In the <a href="http://codepen.io/rachelnabors/pen/PNGGaV">Red Queen Race</a> example, we can inspect Alice and the RedQueen's animation to see its individual keyframes like so:</p>

<pre class="brush: js">// Return the array of keyframes

redQueen_alice.effect.getKeyframes();
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Animations', '#dom-keyframeeffect-getkeyframes', 'KeyframeEffect.getKeyframes()' )}}</td>
   <td>{{Spec2('Web Animations')}}</td>
   <td>Editor's draft.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.KeyframeEffect.getKeyframes")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Web_Animations_API">Web Animations API</a></li>
 <li>Method of {{domxref("KeyframeEffect")}} objects.</li>
</ul>
